<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\Util\Functions;

class cargointerlocController extends TeknisaCrud {
    protected $dataSourceName = 'cargointerloc';
    
    public function __construct ($crudService, $parameterBag, $entityManager){
        $this->parameterBag  = $parameterBag;
        $this->entityManager = $entityManager;
        $this->connection    = $entityManager->getConnection();

        parent::__construct($crudService, $parameterBag);
    }
    
    public function setCargo(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            foreach ($request->getDataSet()->getRows() as &$row) {
                if (\Zeedhi\Framework\Util\Functions::arrayKeyExists('CDCARGOINTERLOC', $row)) {
                    if ($row['__is_new']) {
                        $row['CDCARGOINTERLOC'] = NovoCodigo::geraCodigo($row['NRORG'], "CARGOINTERLOC", 1, 5, false, true);
                    }
                } else {
                    $row['CDCARGOINTERLOC'] = NovoCodigo::geraCodigo($row['NRORG'], "CARGOINTERLOC", 1, 5, false, true);
                }
            }
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}