<?php
namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class Ger01200EstadoFactory {
    #default service
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        #initializes default service
        $this->connection = $entityManager->getConnection();

    }
    public function verficaNomeEstado($row) {
        $params             = array();
        $params['NRORG']    = $row['NRORG'];
        $params['CDPAIS']   = $row['CDPAIS'];
       	$params['NMESTADO'] = strtolower($row['NMESTADO']);

        $sql = "SELECT *
                  	FROM ESTADO
                	WHERE (NRORG = :NRORG OR NRORG = 0) AND CDPAIS = :CDPAIS AND LOWER(NMESTADO) = :NMESTADO";


        $std = $this->connection->prepare($sql);
        $std->execute($params);


        return $std->fetchAll();
    }
    
    public function verficaSiglaEstado($row) {
        try {
            $sql = "SELECT *
                    FROM ESTADO
                    WHERE (NRORG = :NRORG OR NRORG = 0) AND CDPAIS = :CDPAIS AND SGESTADO = :SGESTADO";
    
            $stmt = $this->connection->prepare($sql);
            $stmt->bindParam(':NRORG', $row['NRORG']);
            $stmt->bindParam(':CDPAIS', $row['CDPAIS']);
            $stmt->bindParam(':SGESTADO', $row['SGESTADO']);
            $stmt->execute();
    
            return $stmt->fetch();

        } catch (\PDOException $e) {
            
            throw new \RuntimeException("Erro na verificação da sigla do estado: " . $e->getMessage(), $e->getCode(), $e);
        }
    }


}