<?php

namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class MapFactory{

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
        
    }
    
    public function getLocationsForMap($params, $filters){
        try {
            $queryFilter = '';
            
            // definição das variáveis e valores passados como filtro
            foreach($filters as $filter) {
                if($filter['name'] == 'NRORG' && !empty($filter['value'])) {
                    $params["NRORG"] = $filter['value'];
                    $queryFilter .= ' AND PARC.NRORG = :NRORG';
                }else if($filter['name'] == 'IDATIVO' && !empty($filter['value'])) {
                    $params["IDATIVO"] = strval($filter['value']);
                    $queryFilter .= ' AND PARC.IDATIVO = :IDATIVO';
                }else if($filter['name'] == 'CDOPERADOR' && !empty($filter['value'])) {
                    $params["CDOPERADOR"] = $filter['value'];
                    $queryFilter .= ' AND PARC.CDOPERRESPONSAVEL = (:CDOPERADOR)';
                }else if($filter['name'] == 'CDTIPOPARCPRINCIPAL' && !empty($filter['value'])) {
                    $params["CDTIPOPARCPRINCIPAL"] = $filter['value'];
                    $queryFilter .= ' AND PARC.CDTIPOPARCPRINCIPAL = :CDTIPOPARCPRINCIPAL';
                }else if($filter['name'] == 'CDTIPOINSCRICAO' && !empty($filter['value'])) {
                    $queryFilter .= ' AND PARC.CDTIPOINSCRICAO = :CDTIPOINSCRICAO';
                    $params["CDTIPOINSCRICAO"] = $filter['value'];
                }else if($filter['name'] == 'NRINSCRICAOPARC' && !empty($filter['value'])) {
                    $insc = $filter['value'];
                    $queryFilter .= " AND PARC.NRINSCRICAOPARC LIKE '%".$insc."%'";
                }else if($filter['name'] == 'NMPRINCIPALPARC' && !empty($filter['value'])) {
                    $nmPrincParc = $filter['value'];
                    $queryFilter .= " AND UPPER(PARC.NMPRINCIPALPARC) LIKE UPPER('%".$nmPrincParc."%')";
                }else if($filter['name'] == 'NMSECUNDARIPARC' && !empty($filter['value'])) {
                    $nmSecParc = $filter['value'];
                    $queryFilter .= " AND UPPER(PARC.NMSECUNDARIPARC) LIKE UPPER('%".$nmSecParc."%')";
                }else if($filter['name'] == 'ENDPARC.CDPAIS' && !empty($filter['value'])) {
                    $params["CDPAIS"] = $filter['value'];
                    $queryFilter .= ' AND CDPAIS) = :CDPAIS';
                }else if($filter['name'] == 'ENDPARC.SGESTADO' && !empty($filter['value'])) {
                    $params["SGESTADO"] = $filter['value'];
                    $queryFilter .= ' AND SGESTADO = :SGESTADO';
                }else if($filter['name'] == 'ENDPARC.CDMUNICIPIO' && !empty($filter['value'])) {
                    $params["CDMUNICIPIO"] = $filter['value'];
                    $queryFilter .= ' AND CDMUNICIPIO = :CDMUNICIPIO';
                }else if($filter['name'] == 'CDBAIRRO' && !empty($filter['value'])) {
                    $params["CDBAIRRO"] = $filter['value'];
                    $queryFilter .= ' AND ENDPARC.CDBAIRRO = :CDBAIRRO';
                }else if($filter['name'] == 'CRM_NRORGTRAB' && !empty($filter['value'])) {
                    $params["P_CRM_NRORGTRAB"] = $filter['value'];
                }
            }
            
            $queryGetLocations = "SELECT CDOPERADOR,
                                         CDTIPOPARCPRINCIPAL,
                                         NRPARCNEGOCIO,
                                         DSLATITUDE,
                                         DSLONGITUDE,
                                         ENDERECO,
                                         DSENDERECO,
                                         NMINTERLOCUTOR,
                                         DSTELEFONE,
                                         IDATIVO,
                                         CDTIPOINSCRICAO,
                                         NRINSCRICAOPARC,
                                         NMPRINCIPALPARC,
                                         NMSECUNDARIPARC,
                                         CDPAIS,
                                         SGESTADO,
                                         CDMUNICIPIO,
                                         CDBAIRRO
                                  FROM 
                                    (SELECT DISTINCT 
                                        DECODE(RESP.CDOPERADOR, NULL, PARC.CDOPERRESPONSAVEL, RESP.CDOPERADOR) CDOPERADOR,
                                        STAT.STATUSPARC AS CDTIPOPARCPRINCIPAL,
                                        PARC.NMPRINCIPALPARC,
                                        PARC.NMSECUNDARIPARC,
                                        PARC.NRPARCNEGOCIO,
                                        PARC.IDATIVO,
                                        PARC.NRORG,
                                        PARC.DTINCLUSAO DATAINCLUSAO,
                                        PARC.CDTIPOINSCRICAO,
                                        PARC.NRINSCRICAOPARC,
                                        ENDPARC.DSLATITUDE AS DSLATITUDE, 
                                        ENDPARC.DSLONGITUDE AS DSLONGITUDE,
                                        ENDPARC.CDPAIS AS CDPAIS,
                                        ENDPARC.SGESTADO AS SGESTADO,
                                        ENDPARC.CDMUNICIPIO AS CDMUNICIPIO,
                                        ENDPARC.CDBAIRRO AS CDBAIRRO,
                                        REGEXP_REPLACE(DECODE(ENDPARC.NRCEPENDERECO, NULL, ENDPROSP.NRCEPPROS, ENDPARC.NRCEPENDERECO), '[^0-9]', '') AS ENDERECO,
                                        INITCAP(ENDPARC.DSENDERECO || ', ' || ENDPARC.NRIMOVELENDERECO || ', ' || ENDPARC.SGESTADO) AS DSENDERECO,
                                        INTERLOC.NMINTERLOCUTOR AS NMINTERLOCUTOR,
                                        INTERLOC.NRTELEFONE1 AS DSTELEFONE,
                                        FILACONTATO.DSFILACONTATO, 
                                        FILACONTATO.CDOPERREAL, 
                                        FILACONTATO.NRSEQCLASSIFICATAREFA, 
                                        CLASTAREFA.DSCLASSIFICATAREFA, 
                                        FILACONTATO.DTREALFILACONTA, 
                                        FILACONTATO.NRPRIORFILACONT, 
                                        FILACONTATO.DTPLANFILACONTA, 
                                        SEGMERCADO.CDSEGMER, 
                                        ATIVCLIENTE.CDATIVCLI, 
                                        TPATIVCLIENTE.NRSEQTPATIVCLI, 
                                        MODODIVULG.CDMODODIVULG CDMODODIVULGPARC, 
                                        EVOLCONT.NRCONTATO, 
                                        EVOLCONT.CDTIPOCONT,
                                        EVOLCONT.IDSENEVOCONT, 
                                        EVOLCONT.IDTPEVOLCONT, 
                                        EVOLCONT.CDOPEREVOL, 
                                        EVOLCONT.CDMOTIEVOCON, 
                                        EVOLCONT.NRRELACIONAPARC, 
                                        EVOLCONT.IDANEXOEVOLCONT, 
                                        EVOLCONT.NRSEQRESULEVOL, 
                                        EVOLCONT.NRSEQEVOLCONT, 
                                        EVOLCONT.NRSEQCONTATO, 
                                        EVOLCONT.IDGERAFATURA, 
                                        EVOLCONT.DTHREVOLCONT, 
                                        CRM_RESULTEVOL.NRSEQRESULEVOL,
                                        CASE
                                        WHEN DTPLANFILACONTA IS NOT NULL
                                            AND DTREALFILACONTA IS NOT NULL THEN
                                        'CONCLUIDA'
                                        WHEN DTPLANFILACONTA IS NOT NULL
                                            AND DTREALFILACONTA IS NULL THEN
                                        'EM ABERTO'
                                        WHEN DTPLANFILACONTA IS NULL THEN
                                        ''
                                        END STATUS_TAREFA
                                    FROM PARCNEGOCIO PARC
                                    JOIN CRM_STATUSPARC STAT
                                      ON STAT.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                                          AND STAT.NRORG = PARC.NRORG
                                          AND STAT.CRM_NRORGTRAB = :P_CRM_NRORGTRAB
                                          AND (STAT.IDATIVO = :IDATIVO OR :IDATIVO IS NULL)
                                    LEFT JOIN PROSPECT PROSP
                                        ON PARC.NRORG = PROSP.NRORG
                                            AND PARC.NRPARCNEGOCIO = PROSP.NRPARCNEGOCIO
                                    LEFT JOIN CRM_CANDIDATO LEAD
                                        ON PARC.NRORG = LEAD.NRORG
                                            AND PARC.NRPARCNEGOCIO = LEAD.NRPARCNEGOCIO
                                    LEFT JOIN ENDERECOPARC ENDPARC
                                        ON ENDPARC.NRORG = PARC.NRORG
                                            AND ENDPARC.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                                    LEFT JOIN ENDEPROSPECT ENDPROSP
                                        ON ENDPROSP.NRORG = PARC.NRORG
                                            AND ENDPROSP.CDPROSPECT = PROSP.CDPROSPECT
                                    LEFT JOIN ENDEPROSPECT ENDPROSP
                                        ON ENDPROSP.NRORG = PARC.NRORG
                                            AND ENDPROSP.CDPROSPECT = PROSP.CDPROSPECT
                                    LEFT JOIN CRM_INTERLOCUTOR INTERLOC
                                        ON INTERLOC.NRORG = PARC.NRORG
                                            AND INTERLOC.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                                    LEFT JOIN RELACIONAPARC RELPARC
                                        ON RELPARC.NRORG = PARC.NRORG
                                            AND RELPARC.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                                    LEFT JOIN PARCNEGOCIO INTERLOCANTIGO
                                        ON INTERLOCANTIGO.NRORG = RELPARC.NRORG
                                            AND INTERLOCANTIGO.NRPARCNEGOCIO = RELPARC.NRPARCNEGRELAC
                                    LEFT JOIN COMUNICAPARC COMUNICAINTERLOC
                                        ON COMUNICAINTERLOC.NRPARCNEGOCIO = INTERLOCANTIGO.NRPARCNEGOCIO
                                            AND COMUNICAINTERLOC.NRORG = INTERLOCANTIGO.NRORG
                                            AND COMUNICAINTERLOC.CDFORMACOMU IN ( '01', '02', '03', '04', '06', '10' )
                                    LEFT JOIN OPERADOR RESP
                                        ON RESP.NRPARCNEGOCIO = PROSP.NRPARCRESPROSP
                                            AND RESP.NRORG = PROSP.NRORG
                                    LEFT JOIN CONTATO
                                        ON CONTATO.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                                            AND CONTATO.NRORG = PARC.NRORG
                                            AND ( CONTATO.IDTIPOCONTATO = 'PARCEIRO'
                                            OR CONTATO.DSREFECONT LIKE ( '%Referente ao Lead%' ) )
                                    LEFT JOIN EVOLCONT
                                        ON ( EVOLCONT.NRSEQCONTATO = CONTATO.NRSEQCONTATO )
                                            AND EVOLCONT.NRORG = PARC.NRORG
                                    LEFT JOIN TIPOCONT
                                        ON EVOLCONT.CDTIPOCONT = TIPOCONT.CDTIPOCONT
                                            AND EVOLCONT.NRORG = TIPOCONT.NRORG
                                    LEFT JOIN CRM_RESULTEVOL
                                        ON CRM_RESULTEVOL.NRSEQRESULEVOL = EVOLCONT.NRSEQRESULEVOL
                                            AND CRM_RESULTEVOL.NRORG = EVOLCONT.NRORG
                                    LEFT JOIN MOTIEVOLCONT
                                        ON MOTIEVOLCONT.CDMOTIEVOCON = EVOLCONT.CDMOTIEVOCON
                                            AND MOTIEVOLCONT.NRORG = EVOLCONT.NRORG
                                    LEFT JOIN OPERADOR
                                        ON OPERADOR.CDOPERADOR = PARC.CDOPERRESPONSAVEL
                                    LEFT JOIN FILACONTATO
                                        ON FILACONTATO.NRPARCNEGOCIO = PROSP.NRPARCNEGOCIO
                                            AND FILACONTATO.NRORG = PROSP.NRORG
                                    LEFT JOIN CRM_CLASSIFICATAREFA CLASTAREFA
                                        ON FILACONTATO.NRSEQCLASSIFICATAREFA = CLASTAREFA.NRSEQCLASSIFICATAREFA
                                            AND CLASTAREFA.NRORG = FILACONTATO.NRORG
                                    LEFT JOIN SEGMERCADO
                                        ON SEGMERCADO.CDSEGMER = PARC.CDSEGMER
                                            AND SEGMERCADO.NRORG = PARC.NRORG
                                    LEFT JOIN ATIVCLIENTE
                                        ON ATIVCLIENTE.CDSEGMER = SEGMERCADO.CDSEGMER
                                            AND ATIVCLIENTE.NRORG = SEGMERCADO.NRORG
                                    LEFT JOIN TPATIVCLIENTE
                                        ON TPATIVCLIENTE.CDATIVCLI = ATIVCLIENTE.CDATIVCLI
                                            AND TPATIVCLIENTE.NRORG = ATIVCLIENTE.NRORG
                                    LEFT JOIN MODODIVULG
                                        ON ( MODODIVULG.CDMODODIVULG = PROSP.CDMODODIVULG
                                            OR MODODIVULG.CDMODODIVULG = LEAD.CDMODODIVULG )
                                            AND MODODIVULG.NRORG = PARC.NRORG
                                    WHERE PARC.CDTIPOPARCPRINCIPAL IN ( 'CANDIDATO', 'PROSPECT', 'CLIENTE' )
                                            AND ( ENDPARC.CDTIPOENDERECO = 'PRINCIPAL'
                                            OR ENDPARC.CDTIPOENDERECO IS NULL )
                                            AND ( ENDPROSP.IDTPENDEPROS = 'P'
                                            OR ENDPROSP.IDTPENDEPROS IS NULL )
                                            AND ( ( ENDPARC.DSLATITUDE IS NOT NULL
                                            OR ENDPARC.DSLONGITUDE IS NOT NULL
                                            OR ENDPARC.NRCEPENDERECO IS NOT NULL
                                            OR ENDPROSP.NRCEPPROS IS NOT NULL ) )
                                            $queryFilter
                                          AND ( COMUNICAINTERLOC.NRCOMUNICAPARC = 
                                        (SELECT MAX(NRCOMUNICAPARC)
                                        FROM COMUNICAPARC
                                        WHERE COMUNICAPARC.NRPARCNEGOCIO = COMUNICAINTERLOC.NRPARCNEGOCIO
                                                AND COMUNICAPARC.NRORG = COMUNICAINTERLOC.NRORG
                                                AND COMUNICAPARC.CDFORMACOMU IN ( '01', '02', '03', '04', '06', '10' ) )
                                                OR COMUNICAINTERLOC.NRCOMUNICAPARC IS NULL )
                                                AND ( INTERLOC.NRSEQINTERLOCUTOR = 
                                            (SELECT MAX(NRSEQINTERLOCUTOR)
                                            FROM CRM_INTERLOCUTOR
                                            WHERE INTERLOC.NRPARCNEGOCIO = CRM_INTERLOCUTOR.NRPARCNEGOCIO
                                                    AND CRM_INTERLOCUTOR.NRORG = INTERLOC.NRORG )
                                                    OR INTERLOC.NRSEQINTERLOCUTOR IS NULL )
                                                    AND ( RELPARC.NRRELACIONAPARC = 
                                                (SELECT MAX(NRRELACIONAPARC)
                                                FROM RELACIONAPARC
                                                WHERE RELACIONAPARC.NRPARCNEGOCIO = RELPARC.NRPARCNEGOCIO
                                                        AND RELPARC.NRORG = RELACIONAPARC.NRORG )
                                                        OR RELPARC.NRRELACIONAPARC IS NULL )
                                                        AND ( FILACONTATO.DTPLANFILACONTA = 
                                                    (SELECT MAX(DTPLANFILACONTA)
                                                    FROM FILACONTATO TAREFA
                                                    WHERE TAREFA.NRPARCNEGOCIO = FILACONTATO.NRPARCNEGOCIO
                                                            AND TAREFA.NRORG = FILACONTATO.NRORG )
                                                            OR FILACONTATO.DTPLANFILACONTA IS NULL )
                                                            AND ( EVOLCONT.DTHREVOLCONT = 
                                                        (SELECT MAX(EVOL.DTHREVOLCONT)
                                                        FROM EVOLCONT EVOL
                                                        WHERE EVOL.NRORG = EVOLCONT.NRORG
                                                                AND EVOL.NRSEQCONTATO = EVOLCONT.NRSEQCONTATO )
                                                                OR EVOLCONT.DTHREVOLCONT IS NULL )
                                                        ORDER BY  NMPRINCIPALPARC )
                                                    WHERE ENDERECO IS NOT NULL 
                                            GROUP BY  CDOPERADOR, CDTIPOPARCPRINCIPAL, NRPARCNEGOCIO, DSLATITUDE, DSLONGITUDE, ENDERECO, DSENDERECO, NMINTERLOCUTOR, DSTELEFONE, IDATIVO, CDTIPOPARCPRINCIPAL, CDTIPOINSCRICAO, NRINSCRICAOPARC, NMPRINCIPALPARC, NMSECUNDARIPARC, CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO";   
            
            $std = $this->connection->prepare($queryGetLocations);
            $std->execute($params);
            $locations = $std->fetchAll();
            return $locations;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function insertLocation($params){
        try {
            $sql = "UPDATE ENDERECOPARC 
                                  SET DSLATITUDE = :DSLATITUDE,
                                      DSLONGITUDE = :DSLONGITUDE
                                  WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                                        AND NRORG = :NRORG
                                        AND CDTIPOENDERECO = 'PRINCIPAL'
                                        AND IDATIVO = 'S'";   
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    
}