/***************************************************************************************************************/ 
/*Criao da VIEW (GOP_DRO_VIEW) responsvel por armazenar dados apurados do DRO e Oramento Operacional(GOP) */
/*************************************************************************************************************/
BEGIN
  EXECUTE IMMEDIATE 'DROP MATERIALIZED VIEW GOP_DRO_VIEW';
EXCEPTION
  WHEN OTHERS THEN NULL;
END;
/
CREATE MATERIALIZED VIEW GOP_DRO_VIEW ("NRORG", "CDAREAGERE", "NMAREAGERE", "CDFILIAL", "NMFILIAL", "CDSUPERVISOR", "NMSUPERVISOR", "MES", "ANO", "GOP_VERSAO"
    , "GOP_FAT_BRU", "GOP_CONSUMO", "GOP_MAOBRA", "GOP_DESPMATRIZ", "GOP_DESPDIVERSA", "GOP_DESPESADFE", "GOP_FATLIQU", "GOP_IMPOSTO", "GOP_IMPLUC", "GOP_IMPRECU", "GOP_DEPREC", "GOP_INVEST"
    , "QTDE_DESP_MOB", "QTDE_CONS_COMP", "QTDE_CONS_SAIDA", "QTDE_RET_ESTOQ", "QTDE_RET_PLA", "QTDE_AJUSTES", "QTDE_IMPLANT", "QTDE_FAT_NF", "QTDE_FAT_EFET", "QTDE_DES_CONT_PAG", "QTDE_DESP_DIV", "QTDE_DESP_ENTR", "QTDE_RET_CONS", "QTDE_INVEST", "QTDE_DEPREC_BENS", "QTDE_INV_INICIAL", "QTDE_INV_FINAL"
    , "VALOR_DESP_MOB", "VALOR_CONS_COMP", "VALOR_CONS_SAIDA", "VALOR_RET_ESTOQ", "VALOR_RET_PLA", "VALOR_AJUSTES", "VALOR_IMPLANT", "VALOR_FAT_NF", "VALOR_FAT_EFET", "VALOR_DES_CONT_PAG", "VALOR_DESP_DIV", "VALOR_DESP_ENTR", "VALOR_RET_CONS", "VALOR_INVEST", "VALOR_DEPREC_BENS", "VALOR_INV_INICIAL", "VALOR_INV_FINAL"
    , "IMPOSTO_DESP_MOB", "IMPOSTO_CONS_COMP", "IMPOSTO_CONS_SAIDA", "IMPOSTO_RET_ESTOQ", "IMPOSTO_RET_PLA", "IMPOSTO_AJUSTES", "IMPOSTO_IMPLANT", "IMPOSTO_FAT_NF", "IMPOSTO_FAT_EFET", "IMPOSTO_DES_CONT_PAG", "IMPOSTO_DESP_DIV", "IMPOSTO_DESP_ENTR", "IMPOSTO_RET_CONS", "IMPOSTO_INVEST", "IMPOSTO_DEPREC_BENS", "IMPOSTO_INV_INICIAL", "IMPOSTO_INV_FINAL", "IMPOSTO_REC"
) AS 
-- GOP/DRO 
SELECT NRORG, CDAREAGERE, NMAREAGERE, CDFILIAL, NMFILIAL, CDOPERADOR AS CDSUPERVISOR, NMOPERADOR AS NMSUPERVISOR, MES, ANO, GOP_VERSAO 
     , GOP_FAT_BRU, GOP_CONSUMO, GOP_MAOBRA, GOP_DESPMATRIZ, GOP_DESPDIVERSA, GOP_DESPESADFE, GOP_FATLIQU, GOP_IMPOSTO, GOP_IMPLUC, GOP_IMPRECU, GOP_DEPREC, GOP_INVEST 
     , QTDE_DESP_MOB, QTDE_CONS_COMP, QTDE_CONS_SAIDA, QTDE_RET_ESTOQ, QTDE_RET_PLA, QTDE_AJUSTES, QTDE_IMPLANT, QTDE_FAT_NF, QTDE_FAT_EFET, QTDE_DES_CONT_PAG, QTDE_DESP_DIV, QTDE_DESP_ENTR, QTDE_RET_CONS, QTDE_INVEST, QTDE_DEPREC_BENS, QTDE_INV_INICIAL, QTDE_INV_FINAL 
     , VALOR_DESP_MOB, VALOR_CONS_COMP, VALOR_CONS_SAIDA, VALOR_RET_ESTOQ, VALOR_RET_PLA, VALOR_AJUSTES, VALOR_IMPLANT, VALOR_FAT_NF, VALOR_FAT_EFET, VALOR_DES_CONT_PAG, VALOR_DESP_DIV, VALOR_DESP_ENTR, VALOR_RET_CONS, VALOR_INVEST, VALOR_DEPREC_BENS, VALOR_INV_INICIAL, VALOR_INV_FINAL 
     , IMPOSTO_DESP_MOB, IMPOSTO_CONS_COMP, IMPOSTO_CONS_SAIDA, IMPOSTO_RET_ESTOQ, IMPOSTO_RET_PLA, IMPOSTO_AJUSTES, IMPOSTO_IMPLANT, IMPOSTO_FAT_NF, IMPOSTO_FAT_EFET, IMPOSTO_DES_CONT_PAG, IMPOSTO_DESP_DIV, IMPOSTO_DESP_ENTR, IMPOSTO_RET_CONS, IMPOSTO_INVEST, IMPOSTO_DEPREC_BENS, IMPOSTO_INV_INICIAL, IMPOSTO_INV_FINAL 
     , ROUND(DECODE(VRPERIMPRECUROP,NULL,0,0,0,NVL(VALOR_CONS_COMP,0)*(VRPERIMPRECUROP/100)), 2) AS IMPOSTO_REC 
FROM( 
    SELECT AFS.NRORG, AFS.CDAREAGERE, AFS.NMAREAGERE, AFS.CDFILIAL, AFS.NMFILIAL, AFS.CDOPERADOR, AFS.NMOPERADOR
         , CASE WHEN GOP.MES IS NULL THEN DRO.MES ELSE GOP.MES END AS MES 
         , CASE WHEN GOP.ANO IS NULL THEN DRO.ANO ELSE GOP.ANO END AS ANO 
         , TO_CHAR(NVL(GOP.GOP_VERSAO,-1)) AS GOP_VERSAO 
         , NVL(GOP.GOP_FAT_BRU, 0) AS GOP_FAT_BRU, NVL(GOP.GOP_CONSUMO, 0) AS GOP_CONSUMO, NVL(GOP.GOP_MAOBRA, 0) AS GOP_MAOBRA, NVL(GOP.GOP_DESPMATRIZ, 0) AS GOP_DESPMATRIZ, NVL(GOP.GOP_DESPDIVERSA, 0) AS GOP_DESPDIVERSA, NVL(GOP.GOP_DESPESADFE, 0) AS GOP_DESPESADFE, NVL(GOP.GOP_FATLIQU, 0) AS GOP_FATLIQU, NVL(GOP.GOP_IMPOSTO, 0) AS GOP_IMPOSTO, NVL(GOP.GOP_IMPLUC, 0) AS GOP_IMPLUC, NVL(GOP.GOP_IMPRECU, 0) AS GOP_IMPRECU, NVL(GOP.GOP_DEPREC, 0) AS GOP_DEPREC, NVL(GOP.GOP_INVEST, 0) AS GOP_INVEST 
         , NVL(DRO.QTDE_DESP_MOB, 0) AS QTDE_DESP_MOB, NVL(DRO.QTDE_CONS_COMP, 0) AS QTDE_CONS_COMP, NVL(DRO.QTDE_CONS_SAIDA , 0) AS QTDE_CONS_SAIDA, NVL(DRO.QTDE_RET_ESTOQ , 0) AS QTDE_RET_ESTOQ, NVL(DRO.QTDE_RET_PLA , 0) AS QTDE_RET_PLA, NVL(DRO.QTDE_AJUSTES , 0) AS QTDE_AJUSTES, NVL(DRO.QTDE_IMPLANT , 0) AS QTDE_IMPLANT, NVL(DRO.QTDE_FAT_NF , 0) AS QTDE_FAT_NF, NVL(DRO.QTDE_FAT_EFET , 0) AS QTDE_FAT_EFET, NVL(DRO.QTDE_DES_CONT_PAG , 0) AS QTDE_DES_CONT_PAG, NVL(DRO.QTDE_DESP_DIV , 0) AS QTDE_DESP_DIV, NVL(DRO.QTDE_DESP_ENTR , 0) AS QTDE_DESP_ENTR, NVL(DRO.QTDE_RET_CONS , 0) AS QTDE_RET_CONS, NVL(DRO.QTDE_INVEST , 0) AS QTDE_INVEST, NVL(DRO.QTDE_DEPREC_BENS , 0) AS QTDE_DEPREC_BENS, NVL(DRO.QTDE_INV_INICIAL , 0) AS QTDE_INV_INICIAL, NVL(DRO.QTDE_INV_FINAL , 0) AS QTDE_INV_FINAL 
         , NVL(DRO.VALOR_DESP_MOB, 0) AS VALOR_DESP_MOB, NVL(DRO.VALOR_CONS_COMP, 0) AS VALOR_CONS_COMP, NVL(DRO.VALOR_CONS_SAIDA , 0) AS VALOR_CONS_SAIDA, NVL(DRO.VALOR_RET_ESTOQ , 0) AS VALOR_RET_ESTOQ, NVL(DRO.VALOR_RET_PLA , 0) AS VALOR_RET_PLA, NVL(DRO.VALOR_AJUSTES , 0) AS VALOR_AJUSTES, NVL(DRO.VALOR_IMPLANT , 0) AS VALOR_IMPLANT, NVL(DRO.VALOR_FAT_NF , 0) AS VALOR_FAT_NF, NVL(DRO.VALOR_FAT_EFET , 0) AS VALOR_FAT_EFET, NVL(DRO.VALOR_DES_CONT_PAG , 0) AS VALOR_DES_CONT_PAG, NVL(DRO.VALOR_DESP_DIV , 0) AS VALOR_DESP_DIV, NVL(DRO.VALOR_DESP_ENTR , 0) AS VALOR_DESP_ENTR, NVL(DRO.VALOR_RET_CONS , 0) AS VALOR_RET_CONS, NVL(DRO.VALOR_INVEST , 0) AS VALOR_INVEST, NVL(DRO.VALOR_DEPREC_BENS , 0) AS VALOR_DEPREC_BENS, NVL(DRO.VALOR_INV_INICIAL , 0) AS VALOR_INV_INICIAL, NVL(DRO.VALOR_INV_FINAL , 0) AS VALOR_INV_FINAL 
         , NVL(DRO.IMPOSTO_DESP_MOB, 0) AS IMPOSTO_DESP_MOB, NVL(DRO.IMPOSTO_CONS_COMP, 0) AS IMPOSTO_CONS_COMP, NVL(DRO.IMPOSTO_CONS_SAIDA , 0) AS IMPOSTO_CONS_SAIDA, NVL(DRO.IMPOSTO_RET_ESTOQ , 0) AS IMPOSTO_RET_ESTOQ, NVL(DRO.IMPOSTO_RET_PLA , 0) AS IMPOSTO_RET_PLA, NVL(DRO.IMPOSTO_AJUSTES , 0) AS IMPOSTO_AJUSTES, NVL(DRO.IMPOSTO_IMPLANT , 0) AS IMPOSTO_IMPLANT, NVL(DRO.IMPOSTO_FAT_NF , 0) AS IMPOSTO_FAT_NF, NVL(DRO.IMPOSTO_FAT_EFET , 0) AS IMPOSTO_FAT_EFET, NVL(DRO.IMPOSTO_DES_CONT_PAG , 0) AS IMPOSTO_DES_CONT_PAG, NVL(DRO.IMPOSTO_DESP_DIV , 0) AS IMPOSTO_DESP_DIV, NVL(DRO.IMPOSTO_DESP_ENTR , 0) AS IMPOSTO_DESP_ENTR, NVL(DRO.IMPOSTO_RET_CONS , 0) AS IMPOSTO_RET_CONS, NVL(DRO.IMPOSTO_INVEST , 0) AS IMPOSTO_INVEST, NVL(DRO.IMPOSTO_DEPREC_BENS , 0) AS IMPOSTO_DEPREC_BENS, NVL(DRO.IMPOSTO_INV_INICIAL , 0) AS IMPOSTO_INV_INICIAL, NVL(DRO.IMPOSTO_INV_FINAL , 0) AS IMPOSTO_INV_FINAL 
         , CASE WHEN (SELECT IDUTPADRROP FROM PARAMGERAL)='S' THEN (SELECT VRPERIMPRECUROP FROM PARFILIALROP WHERE NRORG=AFS.NRORG AND CDFILIAL='P') 
           ELSE VIM.VRPERIMPRECUROP END AS VRPERIMPRECUROP 
FROM( 
        -- GOP 
        SELECT * FROM ( 
            SELECT NRORG 
             , CDFILIAL 
             , GOP_VERSAO 
             , MAX(GOP_VERSAO) OVER(PARTITION BY NRORG, ANO) AS MAX_GOP 
             , IDTIPOORCAOP 
             , MES 
             , ANO 
             , VRORCADO 
        FROM( 
            SELECT NRORG 
                 , CDFILIAL 
                 , CDVERSORCAOP AS GOP_VERSAO 
                 , IDTIPOORCAOP 
                 , DECODE(MES_ORCADO,'VRORCAMENTOJAN', '01', 'VRORCAMENTOFEV', '02', 'VRORCAMENTOMAR', '03' 
                         , 'VRORCAMENTOABR', '04', 'VRORCAMENTOMAI', '05', 'VRORCAMENTOJUN','06' 
                         , 'VRORCAMENTOJUL','07', 'VRORCAMENTOAGO','08', 'VRORCAMENTOSET','09' 
                         , 'VRORCAMENTOOUT','10', 'VRORCAMENTONOV','11', 'VRORCAMENTODEZ','12' 
                 , null) AS MES 
                 , NRANOORCAOP AS ANO 
                 , TRUNC(SUM(VRORCAMENTO),2) AS VRORCADO 
            FROM ITEMORCAOP 
            UNPIVOT 
            ( 
                VRORCAMENTO 
                FOR MES_ORCADO IN ("VRORCAMENTOJAN","VRORCAMENTOFEV","VRORCAMENTOMAR","VRORCAMENTOABR","VRORCAMENTOMAI","VRORCAMENTOJUN","VRORCAMENTOJUL","VRORCAMENTOAGO","VRORCAMENTOSET","VRORCAMENTOOUT","VRORCAMENTONOV","VRORCAMENTODEZ") 
            ) 
            GROUP BY NRORG,CDFILIAL,CDVERSORCAOP,IDTIPOORCAOP,NRANOORCAOP,MES_ORCADO 
        ) 
    ) 
    PIVOT 
    ( 
       SUM(VRORCADO) 
       FOR IDTIPOORCAOP IN ('F' AS "GOP_FAT_BRU",'C' AS "GOP_CONSUMO",'O' AS "GOP_MAOBRA",'M' AS "GOP_DESPMATRIZ" 
          ,'D' AS "GOP_DESPDIVERSA",'E' AS "GOP_DESPESADFE",'L' AS "GOP_FATLIQU",'I' AS "GOP_IMPOSTO",'S' AS "GOP_IMPLUC" 
          ,'R' AS "GOP_IMPRECU",'P' AS "GOP_DEPREC",'N' AS "GOP_INVEST" 
       ) 
    ) 
    WHERE GOP_VERSAO = MAX_GOP
    ) GOP 
     
    FULL OUTER JOIN( 
        --DRO 
        SELECT * 
        FROM (SELECT NRORG 
                 , CDFILIAL 
                 , CAMPOITEM||IDTPLANCROP AS MNEMONICO 
                 , TO_CHAR(TO_DATE(DTLANCROP, 'DD/MM/YYYY'),'MM') AS MES
                 , TO_CHAR(TO_DATE(DTLANCROP, 'DD/MM/YYYY'),'YYYY') AS ANO 
                 , VALORITEM 
            FROM(SELECT NRORG 
                      , CDFILIAL 
                      , DTLANCROP 
                      , DECODE(IDTPLANCROP 
                          , 'DM', 'DESP_MOB', 'CC', 'CONS_COMP', 'CS', 'CONS_SAIDA' 
                          , 'RE', 'RET_ESTOQ', 'RP', 'RET_PLA', 'AJ', 'AJUSTES' 
                          , 'IM', 'IMPLANT', 'FS', 'FAT_NF', 'FE', 'FAT_EFET' 
                          , 'DC', 'DES_CONT_PAG', 'DD', 'DESP_DIV', 'DE', 'DESP_ENTR' 
                          , 'R2', 'RET_CONS', 'IV', 'INVEST', 'DB', 'DEPREC_BENS' 
                          , 'II', 'INV_INICIAL', 'IF', 'INV_FINAL', 'PP', 'PRECO_PADRAO' 
                      , NULL) AS IDTPLANCROP 
                      
                      , DECODE(CAMPOITEM, 'QTITEMLANCROP', 'QTDE_' 
                          , 'VRITEMLANCROP', 'VALOR_' 
                          , 'VRITRELITROP', 'IMPOSTO_' 
                      , NULL) AS CAMPOITEM 
                      , VALORITEM 
                 FROM( SELECT NRORG 
                          , CDFILIAL 
                          , '01/'||DTLANCROP AS DTLANCROP
                          , IDTPLANCROP 
                          , TRUNC(SUM(QTITEMLANCROP),2) AS QTITEMLANCROP 
                          , TRUNC(SUM(VRITEMLANCROP),2) AS VRITEMLANCROP 
                          , SUM(VRITRELITROP) AS VRITRELITROP 
                     FROM (                     
                        SELECT NRORG, CDFILIAL, IDTPLANCROP, DTLANCROP, QTITEMLANCROP, VRITEMLANCROP, SUM(VRITRELITROP) AS VRITRELITROP
                        FROM
                        (
                            SELECT PR.NRORG ,PR.CDFILIAL, PR.IDTPLANCROP, PR.DTLANCROP, PR.QTITEMLANCROP, PR.VRITEMLANCROP
                                 , NVL(DECODE(IMP.IDTRATIMPROP,'D', PR.VRITRELITROP *(-1), 'V', 0, PR.VRITRELITROP),0) AS VRITRELITROP
                            FROM
                            (
                                SELECT R.NRORG ,R.CDFILIAL, L.IDTPLANCROP
                                    , CASE
                                      WHEN('S' = (CASE WHEN (SELECT IDUTPADRROP FROM PARAMGERAL)='S' THEN (SELECT IDDTAPURFAT FROM PARFILIALROP WHERE NRORG=R.NRORG AND CDFILIAL='P') ELSE (SELECT IDDTAPURFAT FROM PARFILIALROP WHERE NRORG=R.NRORG AND CDFILIAL=R.CDFILIAL)END)) 
                                      THEN TO_CHAR(L.DTLANCROP, 'MM/YYYY')
                                      WHEN('R' = (CASE WHEN (SELECT IDUTPADRROP FROM PARAMGERAL)='S' THEN (SELECT IDDTAPURFAT FROM PARFILIALROP WHERE NRORG=R.NRORG AND CDFILIAL='P') ELSE (SELECT IDDTAPURFAT FROM PARFILIALROP WHERE NRORG=R.NRORG AND CDFILIAL=R.CDFILIAL)END)) 
                                      THEN (CASE L.IDTPLANCROP WHEN 'FS' THEN TO_CHAR(NVL(L.DTFINREFEROP, L.DTLANCROP), 'MM/YYYY') ELSE TO_CHAR(L.DTLANCROP, 'MM/YYYY') END)
                                      ELSE TO_CHAR(L.DTLANCROP, 'MM/YYYY')
                                      END AS DTLANCROP
                                    , I.QTITEMLANCROP, I.VRITEMLANCROP, IT.CDITRELITROP, IT.VRITRELITROP 
                                FROM ROPFILIAL R 
                                JOIN LANCROPFILIAL L 
                                   ON R.CDFILIAL=L.CDFILIAL 
                                   AND R.NRROPFILIAL=L.NRROPFILIAL 
                                   AND R.NRORG = L.NRORG 
                                JOIN ITLANCROPFILIAL I 
                                   ON L.CDFILIAL = I.CDFILIAL 
                                   AND L.NRROPFILIAL = I.NRROPFILIAL 
                                   AND L.NRLANCROP = I.NRLANCROP 
                                   AND L.NRORG = I.NRORG 
                                LEFT JOIN ITRELACITROP IT
                                   ON IT.CDFILIAL=I.CDFILIAL 
                                   AND IT.NRROPFILIAL=I.NRROPFILIAL 
                                   AND IT.NRLANCROP=I.NRLANCROP 
                                   AND IT.NRITLANCROP=I.NRITLANCROP 
                                   AND IT.NRORG=I.NRORG 
                                WHERE ( 
                                   ( L.DTLANCROP = ( 
                                       CASE 
                                       WHEN TO_CHAR(SYSDATE, 'MM/YYYY') NOT LIKE TO_CHAR(L.DTLANCROP, 'MM/YYYY')
                                       THEN TO_DATE('01/'||TO_CHAR(L.DTLANCROP, 'MM/YYYY'),'DD/MM/YYYY')
                                       ELSE TO_DATE('01/'|| TO_CHAR(SYSDATE, 'MM/YYYY'), 'DD/MM/YYYY') 
                                       END 
                                   ) AND L.IDTPLANCROP = 'II') 
                                   OR (L.DTLANCROP = ( 
                                       CASE  
                                       WHEN TO_CHAR(SYSDATE, 'MM/YYYY') NOT LIKE TO_CHAR(L.DTLANCROP, 'MM/YYYY')
                                       THEN LAST_DAY(TO_DATE('01/'||TO_CHAR(L.DTLANCROP, 'MM/YYYY'), 'DD/MM/YYYY')) 
                                       ELSE TO_DATE(SYSDATE-1, 'DD/MM/YYYY') 
                                       END
                                    ) AND L.IDTPLANCROP = 'IF') 
                                   OR L.IDTPLANCROP IN ('DM','CC','CS','RE','RP','AJ','IM','FS','FE','DC','DD','DE','R2','IV','DB','PP')
                                )
                                ORDER BY R.NRORG, R.CDFILIAL, L.DTLANCROP, IT.CDITRELITROP
                            ) PR
                            LEFT JOIN 
                            (
                                SELECT NRORG, CDIMPOSTO, CDFILIAL
                                     , IDTPIMPOSTOROP, IDTRATIMPROP
                                FROM 
                                (
                                    SELECT NRORG, CDIMPOSTO, CDFILIAL
                                         , IDTPIMPOSTOROP, IDTRATIMPROP
                                         , COUNT(*) OVER (PARTITION BY NRORG, CDFILIAL, IDTPIMPOSTOROP ORDER BY NRORG, CDIMPOSTO, CDFILIAL, IDTPIMPOSTOROP) AS QTDEIMPOSTO
                                    FROM IMPOSTOROP
                                )
                                WHERE QTDEIMPOSTO <= 5
                            ) IMP
                                ON IMP.NRORG = PR.NRORG
                                AND IMP.CDIMPOSTO = PR.CDITRELITROP
                                AND IMP.CDFILIAL = TIPOPARAM_DRO(PR.CDFILIAL)
                                AND IMP.IDTPIMPOSTOROP = PR.IDTPLANCROP
                        )
                        GROUP BY NRORG ,CDFILIAL, IDTPLANCROP, DTLANCROP, QTITEMLANCROP, VRITEMLANCROP
                     )  
                     GROUP BY NRORG,CDFILIAL,DTLANCROP,IDTPLANCROP
                 ) UNPIVOT ( 
                     VALORITEM FOR CAMPOITEM IN ("QTITEMLANCROP","VRITEMLANCROP","VRITRELITROP") 
                 ) 
            )
        ) 
        PIVOT( 
            SUM(VALORITEM) FOR MNEMONICO IN('QTDE_DESP_MOB' AS "QTDE_DESP_MOB", 'QTDE_CONS_COMP' AS "QTDE_CONS_COMP", 'QTDE_CONS_SAIDA' AS "QTDE_CONS_SAIDA", 'QTDE_RET_ESTOQ' AS "QTDE_RET_ESTOQ", 'QTDE_RET_PLA' AS "QTDE_RET_PLA", 'QTDE_AJUSTES' AS "QTDE_AJUSTES", 'QTDE_IMPLANT' AS "QTDE_IMPLANT", 'QTDE_FAT_NF' AS "QTDE_FAT_NF", 'QTDE_FAT_EFET' AS "QTDE_FAT_EFET", 'QTDE_DES_CONT_PAG' AS "QTDE_DES_CONT_PAG", 'QTDE_DESP_DIV' AS "QTDE_DESP_DIV", 'QTDE_DESP_ENTR' AS "QTDE_DESP_ENTR", 'QTDE_RET_CONS' AS "QTDE_RET_CONS", 'QTDE_INVEST' AS "QTDE_INVEST", 'QTDE_DEPREC_BENS' AS "QTDE_DEPREC_BENS", 'QTDE_INV_INICIAL' AS "QTDE_INV_INICIAL", 'QTDE_INV_FINAL' AS "QTDE_INV_FINAL", 'QTDE_PRECO_PADRAO' AS "QTDE_PRECO_PADRAO" 
        , 'VALOR_DESP_MOB' AS "VALOR_DESP_MOB", 'VALOR_CONS_COMP' AS "VALOR_CONS_COMP", 'VALOR_CONS_SAIDA' AS "VALOR_CONS_SAIDA", 'VALOR_RET_ESTOQ' AS "VALOR_RET_ESTOQ", 'VALOR_RET_PLA' AS "VALOR_RET_PLA", 'VALOR_AJUSTES' AS "VALOR_AJUSTES", 'VALOR_IMPLANT' AS "VALOR_IMPLANT", 'VALOR_FAT_NF' AS "VALOR_FAT_NF", 'VALOR_FAT_EFET' AS "VALOR_FAT_EFET", 'VALOR_DES_CONT_PAG' AS "VALOR_DES_CONT_PAG", 'VALOR_DESP_DIV' AS "VALOR_DESP_DIV", 'VALOR_DESP_ENTR' AS "VALOR_DESP_ENTR", 'VALOR_RET_CONS' AS "VALOR_RET_CONS", 'VALOR_INVEST' AS "VALOR_INVEST", 'VALOR_DEPREC_BENS' AS "VALOR_DEPREC_BENS", 'VALOR_INV_INICIAL' AS "VALOR_INV_INICIAL", 'VALOR_INV_FINAL' AS "VALOR_INV_FINAL", 'VALOR_PRECO_PADRAO' AS "VALOR_PRECO_PADRAO" 
        , 'IMPOSTO_DESP_MOB' AS "IMPOSTO_DESP_MOB", 'IMPOSTO_CONS_COMP' AS "IMPOSTO_CONS_COMP", 'IMPOSTO_CONS_SAIDA' AS "IMPOSTO_CONS_SAIDA", 'IMPOSTO_RET_ESTOQ' AS "IMPOSTO_RET_ESTOQ", 'IMPOSTO_RET_PLA' AS "IMPOSTO_RET_PLA", 'IMPOSTO_AJUSTES' AS "IMPOSTO_AJUSTES", 'IMPOSTO_IMPLANT' AS "IMPOSTO_IMPLANT", 'IMPOSTO_FAT_NF' AS "IMPOSTO_FAT_NF", 'IMPOSTO_FAT_EFET' AS "IMPOSTO_FAT_EFET", 'IMPOSTO_DES_CONT_PAG' AS "IMPOSTO_DES_CONT_PAG", 'IMPOSTO_DESP_DIV' AS "IMPOSTO_DESP_DIV", 'IMPOSTO_DESP_ENTR' AS "IMPOSTO_DESP_ENTR", 'IMPOSTO_RET_CONS' AS "IMPOSTO_RET_CONS", 'IMPOSTO_INVEST' AS "IMPOSTO_INVEST", 'IMPOSTO_DEPREC_BENS' AS "IMPOSTO_DEPREC_BENS", 'IMPOSTO_INV_INICIAL' AS "IMPOSTO_INV_INICIAL", 'IMPOSTO_INV_FINAL' AS "IMPOSTO_INV_FINAL" , 'IMPOSTO_PRECO_PADRAO' AS "IMPOSTO_PRECO_PADRAO") 
        )
    
    ) DRO 
    ON DRO.NRORG = GOP.NRORG 
    AND DRO.CDFILIAL = GOP.CDFILIAL 
    AND DRO.MES = GOP.MES 
    AND DRO.ANO = GOP.ANO 
 
    RIGHT JOIN (
        SELECT FI.NRORG, AR.CDAREAGERE, AR.NMAREAGERE, FI.CDFILIAL, FI.NMFILIAL, OP.CDOPERADOR, OP.NMOPERADOR
        FROM FILIAL FI
        LEFT JOIN AREAGERE AR
            ON AR.NRORG = FI.NRORG
            AND AR.CDAREAGERE = FI.CDAREAGERE
        LEFT JOIN OPERADOR OP
            ON OP.NRORG = FI.NRORG
            AND OP.CDOPERADOR = FI.CDSUPERVISOR
    ) AFS 
    ON (AFS.NRORG = CASE WHEN GOP.NRORG IS NULL THEN DRO.NRORG ELSE GOP.NRORG END)
    AND (AFS.CDFILIAL = CASE WHEN GOP.CDFILIAL IS NULL THEN DRO.CDFILIAL ELSE GOP.CDFILIAL END)
     
    LEFT JOIN ( 
        SELECT PF.NRORG, PF.CDFILIAL, PG.IDUTPADRROP 
             , CASE WHEN PG.IDUTPADRROP='S' OR PF.IDUTPADRROPFIL='S' 
               THEN (SELECT VRPERIMPRECUROP FROM PARFILIALROP WHERE CDFILIAL = 'P')  
               ELSE PF.VRPERIMPRECUROP END AS VRPERIMPRECUROP  
               FROM PARFILIALROP PF, PARAMGERAL PG 
    ) VIM 
    ON (VIM.NRORG = CASE WHEN GOP.NRORG IS NULL THEN DRO.NRORG ELSE GOP.NRORG END)
    AND (VIM.CDFILIAL = CASE WHEN GOP.CDFILIAL IS NULL THEN DRO.CDFILIAL ELSE GOP.CDFILIAL END)
)
ORDER BY NRORG, CDFILIAL, ANO, MES, GOP_VERSAO
/
-- VERSAO --
BEGIN ATUVEROBJ('GOP_DRO_VIEW','6.00.xxx'); END;
/