var Application = function(localStorageEngine, templateManager, ScreenService, restEngine, ZHPromise, eventAggregator){

  var self = this;

  /*var hasRuned = false;

  eventAggregator.subscribe('onContainerOpen', function(){
    if(!hasRuned){
      ScreenService.openWindow('product#dashboard');
      hasRuned = true;
    }
  });*/

  this.login = function(widget){

    var user = widget.currentRow.CDOPERADOR;
    var password = widget.currentRow.CDSENHAOPER;

    var filters = [{
      "name": "user",
      "value": user,
      "operator": "="
    }, {
      "name": "password",
      "value": password,
      "operator": "="
    }];

    localStorageEngine.download('/login/login', filters).then(function(data){
        var userId = data.login;
        templateManager.userId = userId;
        var accessProfiles = getLocalVar('NRGROUPCTLACESS');
        localStorageEngine.setLocalVar('login', user);
        localStorageEngine.setLocalVar('PROJECT_ID', 13);
        self.getRules(accessProfiles).then( //remove the hash when query is ready
            function(response) {
                var data = response.dataset.zhu_access_control_rule_login;
                var rules = {};
                data.forEach(
                    function(rule) {
                        var profileObject = {
                            'rule': rule.RULE
                        };
                        var profileObjects = {};
                        profileObjects[userId] = profileObject;
                        rules[rule.NAME] = {
                            'itemName': rule.NAME,
                            'userGroups': profileObjects
                        };
                    }
                );
                templateManager.aclRules = rules;
                ScreenService.openWindow('dashboard');
            }
        );


        ScreenService.buildUserData(data.userData.nmoperador, [data.userData.nmEstrutLegalOper,""],function(){
            ScreenService.successNotification("Logado com sucesso!");
        });
    });
  };
    this.autenticar = function(widget){

        var user = widget.currentRow.CDOPERADOR;
        var password = widget.currentRow.CDSENHAOPER;

        var filters = [{
            "name": "user",
            "value": user,
            "operator": "="
        }, {
            "name": "password",
            "value": password,
            "operator": "="
        }];

        localStorageEngine.download('/login/login', filters).then(function(data){
            var userId = data.login;
            templateManager.userId = userId;
            var accessProfiles = getLocalVar('NRGROUPCTLACESS');
            localStorageEngine.setLocalVar('login', user);
            localStorageEngine.setLocalVar('PROJECT_ID', 13);
            self.getRules(accessProfiles).then( //remove the hash when query is ready
                function(response) {
                    var data = response.dataset.zhu_access_control_rule_login;
                    var rules = {};
                    data.forEach(
                        function(rule) {
                            var profileObject = {
                                'rule': rule.RULE
                            };
                            var profileObjects = {};
                            profileObjects[userId] = profileObject;
                            rules[rule.NAME] = {
                                'itemName': rule.NAME,
                                'userGroups': profileObjects
                            };
                        }
                    );
                    templateManager.aclRules = rules;
                }
            );


            ScreenService.buildUserData(data.userData.nmoperador, [data.userData.nmEstrutLegalOper,""],function(){
                ScreenService.successNotification("Logado com sucesso!");
            });
        });
    };

  this.loginKeyEnter = function(widget){
      if(event.keyCode === 13){
          this.login(widget);
      }
  };

  this.onEnter = function(widget) {
      Operador_Repository.retornaOperadorLogado().then(function(operator)
      {
        if(operator[0] === undefined || operator[0] === null)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
            return;
        }

        widget.getField('CDSENHAOPER').setValue('');
        widget.getField('CDOPERADOR').setValue(localStorageEngine.operator[0].DSEMAILOPER);
      }, function(error)
      {
          ScreenService.showMessage("Erro ao realizar a operação.");
      });
  };

    self.getRules = function(groupIds) {
        return restEngine.post('/zhu_acl_element_login',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "GROUP_ID",
                        "operator": "=",
                        "value": groupIds
                    }
                ]
            }
        );
    };

   /* this.prepareData = function(args) {
      if (localStorageEngine.getLocalVar("avaliacao").SITUACAO == 'CONCLUIDA') {
      alert("A avaliação já foi concluída. Por isto, não pode mais ser modificada.");
    } else {
        var dataAvaliacao = localStorageEngine.getLocalVar("avaliacao");
        dataAvaliacao.NRORG = localStorageEngine.getLocalVar('NRORG');
        dataAvaliacao.CDOPERADOR = localStorageEngine.getLocalVar('CDOPERADOR');
        dataAvaliacao.changed = true;
        dataAvaliacao.answers = args.owner.widget.dataSource.data[0].answer;
        //console.log(dataAvaliacao);
        localStorageEngine.setDataSource('/questionario', dataAvaliacao, function () {
          restEngine.post('/questionario/save',{"requestType":"Row","row":dataAvaliacao},function () {
            alert('Registro salvo com sucesso.');
          });
        });
    }
    }*/

  this.prepareDataConcluir = function(args) {
    if (localStorageEngine.getLocalVar("avaliacao").SITUACAO == 'CONCLUIDA')
    {
      alert("A avaliação já foi concluída. Por isto, não pode mais ser modificada.");
    }
    else
    {

      Operador_Repository.retornaOperadorLogado().then(function(operator)
      {
        if(operator[0] === undefined || operator[0] === null)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
            return;
        }

        dataAvaliacao = localStorageEngine.getLocalVar("avaliacao");
      	dataAvaliacao.concluir = true;
        dataAvaliacao.NRORG = localStorageEngine.operator[0].NRORG;
        dataAvaliacao.CDOPERADOR = localStorageEngine.operator[0].CDOPERADOR;
        dataAvaliacao.changed = true;
        dataAvaliacao.answers = args.owner.widget.dataSource.data[0].answer;
        localStorageEngine.setDataSource('crm#/questionario', dataAvaliacao, function () {
            restEngine.post('crm#/questionario/save',{"requestType":"Row","row":dataAvaliacao},function ()
            {
                var arrPro = [ScreenService.goBack()];
                ZHPromise.all(arrPro).then(function() {
                    var widget = templateManager.container.getWidget('avaliacao_desempenho');
                    widget.reload();
                    ScreenService.showMessage("Avaliação concluída com sucesso.");
                });
            }, undefined, function(error){
                console.log(error);
            });
        });
      }, function(error)
      {
          ScreenService.showMessage("Erro ao realizar a operação.");
      });
    }
  };

  this.verificaLocalStorage = function() {
    if (!localStorageEngine.getLocalVar("operador_avaliado")) {
      return '';
    } else {
      return localStorageEngine.getLocalVar("operador_avaliado").OPERADOR_AVALIADO;
    }
  };

  this.clearLocalStorage = function(exceptions) {
    //localStorage.clear();
      var storage = localStorage;
      var keys = [];
      exceptions = [].concat(exceptions); //prevent undefined

      //get storage keys
      $.each(localStorage, function(key, val) {
          keys.push(key);
      });

      //loop through keys
      for( i=0; i<keys.length; i++ ){
          var key = keys[i];
          var deleteItem = true;
          //check if key excluded
          for( j=0; j<exceptions.length; j++ ){
              var exception = exceptions[j];
              if( key == exception ) deleteItem = false;
          }
          //delete key
          if( deleteItem ){
              localStorage.removeItem(key);
          }
      }
      ScreenService.openWindow('login');
  };

    this.onClickRecuperarSenha = function(args) {
        var widgetPai = args.owner.field.widget;
        var widget = widgetPai.widgets[0];
        console.log(widget);
        widget.currentRow.DSEMAILOPER = widgetPai.currentRow.CDOPERADOR;
        ScreenService.openPopup(widget);
    };

    this.recuperarSenha = function(dataSet) {
        return restEngine.post("crm#/login/recuperarSenha",
            {
                requestType: "DataSet",
                dataset: [dataSet]
            }
        ).then(function(data) {
                ScreenService.showMessage(data.messages[0].message);
                ScreenService.closePopup();
            });
    };
};


Configuration(function(ContextRegister) {
    ContextRegister.register('questionarioAppControllerRules', Application);
});